#include <iostream>
#include <vector>

using namespace std;

const int delta = 29123;

bool p[2 * delta + 1]; // p[i] = false <-> i is prime

inline int length (int x) {
	int res = 0;
	while (x > 0) res++, x /= 2;
	return res;
}

int dis (int x, int y) {
	int xl = length (x) - 1, yl = length (y) - 1;
	while (xl >= 0 && yl >= 0 && ((x >> xl) & 1) == ((y >> yl) & 1))
		xl--, yl--;

	return xl + yl + 2;
}

int main() {
//	int delta; cin >> delta;

	vector <int> primes;
	p[0] = p[1] = true;
	for (int i = 2; i <= 2 * delta; i++) if (!p[i]) {
		for (int j = 2 * i; j <= 2 * delta; j += i) p[j] = true;
		if (i <= delta) primes.push_back (i);
	}

	cerr << primes.size() << endl;
	int res = 1;
	for (int i = 0; i < primes.size(); i++)
		for (int j = i + 1; j < primes.size(); j++)
			if (!p[primes[i] + primes[j] + 1])
				res = (res * dis (primes[i], primes[j])) % ::delta;
	cout << res << endl;

	return 0;
}
